<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import { flip } from "svelte/animate";
  import { crossfade } from "svelte/transition";
  import Bullhead from "./lib/Bullhead.svelte";
  import Card from "./lib/Card.svelte";
  import {
    getActivePlayers,
    getTakableRows,
    playerCanPlaceCard,
  } from "./lib/domain";
  import EmptyCardSlot from "./lib/EmptyCardSlot.svelte";
  import PhaseDescription from "./lib/PhaseDescription.svelte";
  import Scoreboard from "./lib/Scoreboard.svelte";
  import { getPlayerOrder, range, sorted } from "./lib/utils";

  let animationDuration = (d: number) => Math.sqrt(d * 400);
  const [send, receive] = crossfade({
    duration: animationDuration,
  });

  const dispatch = createEventDispatcher();
  function performAction(action: Action) {
    dispatch("action", action);
  }

  export let state: GameState;
  export let playerId: PlayerId | null;
  // export let settings: GameSettings;

  $: playerOrder = getPlayerOrder(state.players, playerId);

  $: activePlayers = getActivePlayers(state);

  let isActive: (playerId: PlayerId) => boolean;
  $: isActive = (playerId) => activePlayers.includes(playerId);

  let user: PlayerState | null;
  $: user = state.players.find((p) => p.id === playerId) ?? null;

  function getPlayerStyle(playerCount: number, playerIndex: number): string {
    let radius = 24 + playerCount / 2;
    let angle;

    if (playerIndex === 0) {
      angle = 0.5 * Math.PI;
    } else {
      let startAngle = 0.6 * Math.PI;

      let angleStep = (1.8 * Math.PI) / playerCount;
      angle = startAngle + angleStep * playerIndex;
    }

    return `
      --translate-x: ${(radius * Math.cos(angle)).toFixed(2)}rem;
      --translate-y: ${(radius * Math.sin(angle)).toFixed(2)}rem;
    `;
  }

  function isCardButtonEnabled(
    state: GameState,
    playerId: PlayerId,
    userId: PlayerId
  ): boolean {
    return (
      state.phase.k === "Playing" && playerId === userId && isActive(playerId)
    );
  }

  let takableRows: number[];
  $: takableRows = user ? getTakableRows(state, user.id) : [];

  let selectedRow: number | null = null;
  $: {
    if (selectedRow !== null && !takableRows.includes(selectedRow)) {
      selectedRow = null;
    } else if (takableRows.length === 1) {
      selectedRow = takableRows[0];
    }
  }
</script>

<div class="game">
  <div class="center">
    <div class="above-rows">
      <PhaseDescription {state} />
    </div>
    <div class="rows">
      {#each state.rows as row, rowIndex}
        <label class="row" class:selected={selectedRow === rowIndex}>
          <input
            type="radio"
            bind:group={selectedRow}
            value={rowIndex}
            disabled={!user ||
              !activePlayers.includes(user.id) ||
              !takableRows.includes(rowIndex)}
          />
          <div class="background">
            {#each range(0, 6) as cardIndex}
              <div class="row-card">
                <EmptyCardSlot danger={cardIndex === 5} />
              </div>
            {/each}
          </div>
          {#each row as card (card)}
            <div
              class="row-card"
              animate:flip={{ duration: animationDuration }}
            >
              <div in:receive={{ key: card }} out:send={{ key: card }}>
                <Card {card} />
              </div>
            </div>
          {/each}
        </label>
      {/each}
    </div>
    <div class="below-rows">
      {#if user && isActive(user.id) && playerCanPlaceCard(state, user.id)}
        <div class="player-ready">
          <button
            on:click={() => performAction({ k: "Ready" })}
            class="primary"
          >
            Place card
          </button>
        </div>
      {/if}
      {#if user && isActive(user.id) && state.phase.k === "RoundComplete"}
        <div class="player-ready">
          <button
            on:click={() => performAction({ k: "Ready" })}
            class="primary"
          >
            I'm ready!
          </button>
        </div>
      {/if}
      {#if user && activePlayers.includes(user.id) && takableRows.length > 0}
        <button
          disabled={selectedRow === null}
          on:click={() => {
            selectedRow !== null &&
              performAction({ k: "Take", v: { row: selectedRow } });
          }}
          class="primary">Take row</button
        >
      {/if}
    </div>
  </div>
  <div class="players">
    {#each state.players as player (player.id)}
      <div
        class="player"
        class:user={player.id === playerId}
        class:not-user={player.id !== playerId}
        style={getPlayerStyle(
          state.players.length,
          playerOrder.indexOf(player.id)
        )}
      >
        <div class="player-inner">
          <div class="player-hand">
            {#each player.id === playerId ? sorted(player.hand) : player.hand as card, cardIdx (card)}
              <button
                class="player-card"
                on:click={() => performAction({ k: "Play", v: { card } })}
                disabled={user
                  ? !isCardButtonEnabled(state, player.id, user.id)
                  : true}
                style="
                  --card-index: {cardIdx};
                  --card-index-offset: {(player.hand.length - 1) / 2};
                "
              >
                <div in:receive={{ key: card }} out:send={{ key: card }}>
                  <Card {card} faceDown={player.id !== playerId} />
                </div>
              </button>
            {/each}
          </div>
          <div class="taken-cards">
            {#each player.taken as card (card)}
              <div class="taken-card">
                <div in:receive={{ key: card }} out:send={{ key: card }}>
                  <Card {card} />
                </div>
              </div>
            {/each}
          </div>
          <gs6-player-box
            userid={player.id}
            active={activePlayers.includes(player.id)}
          >
            <div class="player-bulls">
              <span class="player-bulls-icon">
                <Bullhead />
              </span>
              &times; {player.score}
            </div>
          </gs6-player-box>
          {#if (state.phase.k === "Playing" || state.phase.k === "Placing") && player.played !== null}
            <div class="played-card">
              <div
                in:receive={{ key: player.played }}
                out:send={{ key: player.played }}
              >
                <Card
                  card={player.played}
                  faceDown={(() => {
                    switch (state.phase.k) {
                      case "Playing":
                        return player.id !== playerId;
                      case "Placing":
                        return false;
                    }
                  })()}
                />
              </div>
            </div>
          {/if}
        </div>
      </div>
    {/each}
  </div>

  {#if state.phase.k === "RoundComplete" || state.phase.k === "GameComplete"}
    <div class="prompt panel">
      <Scoreboard {state} />
    </div>
  {/if}
</div>

<style>
  :root {
    --gs6-bullheaded-purple: hsl(240, 50%, 40%);
  }

  .game {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  .center {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);

    display: grid;
    grid-template-columns: 1fr;
    grid-template-rows: 1fr auto 1fr;
  }

  .above-rows,
  .below-rows {
    text-align: center;
    height: 5rem;
    display: grid;
    place-content: center;
  }

  .above-rows {
    margin-bottom: 0.75rem;
  }
  .below-rows {
    margin-top: 0.75rem;
  }

  .center .rows {
    display: grid;
    grid-template-rows: repeat(4, 1fr);
    gap: 0.5rem;
    font-size: 75%;
  }
  .center .row {
    display: flex;
    flex-direction: row;
    flex-wrap: nowrap;
    gap: 0.5rem;
    width: calc(6 * 5em + 5 * 0.5rem);
    position: relative;
  }

  .center .row > input[type="radio"] {
    position: absolute;
    top: 50%;
    left: 0;
    transform: translate(-100%, -50%) translateX(-1.25rem) scale(1.25);
  }
  .center .row > input[type="radio"]:disabled {
    visibility: hidden;
  }

  .center label.row.selected::after {
    content: "";
    position: absolute;
    top: -0.125rem;
    left: -0.125rem;
    right: calc(5em + 0.5rem - 0.125rem);
    bottom: -0.125rem;
    border-radius: 0.25rem;
    box-shadow: 0 0 0 0.25rem #1786ec8f;
  }

  .row-card {
    position: relative;
  }

  .background {
    position: absolute;
    top: 0;
    left: 0;

    display: grid;
    grid-template-columns: repeat(6, 1fr);
    gap: 0.5rem;
  }

  .player {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%)
      translate(var(--translate-x), var(--translate-y));
    transition: transform 0.5s;
  }
  .player-inner {
    position: relative;
  }
  .player-bulls {
    text-align: center;
  }
  .player-bulls-icon {
    color: var(--gs6-bullheaded-purple);
  }

  button.player-card {
    border: none;
    font: inherit;
    padding: 0;
    background: none;
    text-align: inherit;

    position: absolute;
    left: 50%;
    top: 0;
    transform-origin: center 55em;
    transform: translate(-50%, -100%) translateY(1em)
      rotate(calc((var(--card-index) - var(--card-index-offset)) * 4deg));

    transition: transform 0.2s;
  }

  button.player-card:not(:disabled) {
    cursor: pointer;
  }

  button.player-card:disabled {
    color: inherit;
  }

  button.player-card:hover:not(:disabled),
  button.player-card:focus-within:not(:disabled) {
    transform: translate(-50%, -100%) translateY(1em)
      rotate(calc((var(--card-index) - var(--card-index-offset)) * 4deg))
      translateY(-1.5em);
  }

  .not-user button.player-card {
    font-size: 67%;
    transform-origin: center 30em;
    transform: translate(-50%, -100%) translateY(1em)
      rotate(calc((var(--card-index) - var(--card-index-offset)) * 2.5deg));
  }

  .played-card {
    font-size: 85%;

    position: absolute;
    left: 50%;
    bottom: 0;
    transform: translate(-50%, 100%) translateY(-0.5rem);
  }

  .taken-card {
    position: absolute;
    font-size: 50%;

    left: 50%;
    bottom: 0.1rem;
    transform: translateX(-50%);
  }

  .prompt {
    position: absolute;
    left: 50%;
    top: 50%;
    transform: translate(-50%, -50%);
  }
</style>
